VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Blob Test"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton CmdOut 
      Caption         =   "Read Blob Out"
      Height          =   555
      Left            =   570
      TabIndex        =   1
      Top             =   1500
      Width           =   1425
   End
   Begin VB.CommandButton CmdIn 
      Caption         =   "Put Blob In"
      Height          =   525
      Left            =   570
      TabIndex        =   0
      Top             =   840
      Width           =   1425
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Alastair Vance (al@alvance.co.uk)
' 26-FEB-2002
'
' Project to test blob import and export
' from an oracle (8.1.7.2) database using ADO and
' Software Artisans FileManager component.
'
' Oracle 8.1.7.2 client used.
'
' VB Project References needed:
'   Microsoft ActiveX Data Objects Library 2.x
'   FileManager 1.1
'
' Oracle Database Table Script:
'
'   CREATE TABLE BLOBTEST (
'     DOCTITLE  VARCHAR2 (50),
'     DOCDESC   VARCHAR2 (255),
'     DOCBIN    BLOB ) ;





Option Explicit


Private Sub CmdIn_Click()

    Dim Conn As New ADODB.Connection
    Dim Rs As New ADODB.Recordset
    Dim FileMgr As New FileManager
    
    Dim SQL As String
        
    ' Using OLEDB to connect
    Conn.Provider = "OraOLEDB.Oracle"
    Conn.Open "service", "username", "password"
    
    ' Delete all current rows
    SQL = "Truncate table blobtest"
    Conn.Execute SQL
    
    ' Add new row with file
    SQL = "Select * from blobtest where 1=2"
    Rs.Open SQL, Conn, 2, 3
    
    Rs.AddNew
    Rs("doctitle").Value = "Test " & Now
    Rs("docdesc").Value = "Description of Document."
    ' Puts file into database blob
    FileMgr.ExportToBlob "c:\autocryptmanual.pdf", Rs("docbin")
        
    Rs.Update
        
    ' Close recordset and database connection
    Rs.Close
    Conn.Close
    
    Set Conn = Nothing
    
    MsgBox "Finished."

End Sub

Private Sub CmdOut_Click()

    Dim Conn As New ADODB.Connection
    Dim Rs As New ADODB.Recordset
    Dim FileMgr As New FileManager
    
    Dim SQL As String
    Dim DocTitle As String
    Dim DocDesc As String
            
    ' OLEDB connection
    Conn.Provider = "OraOLEDB.Oracle"
    Conn.Open "service", "username", "password"
        
    ' Read all from table
    SQL = "Select * from blobtest"
    Rs.Open SQL, Conn, 0, 1
        
        ' Put data fields into local variables for
        ' use later on (after recordset is closed)
        DocTitle = Rs("doctitle")
        DocDesc = Rs("docdesc")
        ' Get and save file at specified location.
        ' I use a timestamp here to assure uniqueness of
        ' the filename.  You could simply check that the
        ' file exists first before choosing a filename.
        FileMgr.ImportFromBlob Rs("docbin"), "c:\" & GetTimeStamp & "newmanual.pdf"
            
            
    ' Close recordset and database connection
    Rs.Close
    Conn.Close
    
    Set Conn = Nothing
    
    ' Inform user that process has finished.
    MsgBox "Blob extracted.", , DocTitle
        


End Sub


Private Function GetTimeStamp() As String

    ' Using the time and date I can create a unique
    ' number for the application to use.
    GetTimeStamp = Replace(Replace(Replace(Now, ":", ""), " ", ""), "/", "")


End Function
